#ifndef C_SPRITE_H
#define C_SPRITE_H

//****************************************************************************************************
// 
//****************************************************************************************************

//****************************************************************************************************
// 
//****************************************************************************************************
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <memory>

#include "ivideo.h"
#include "tga.h"

//****************************************************************************************************
//
//****************************************************************************************************

//****************************************************************************************************
//
//****************************************************************************************************

//****************************************************************************************************
// 
//****************************************************************************************************

//****************************************************************************************************
// 
//****************************************************************************************************
class CSprite
{
 public:
  //----------------------------------------------------------------------------------------
  //-------------------------------------------------------------------------------------------
  //-------------------------------------------------------------------------------------------
 private:
  //------------------------------------------------------------------------------------------
  int32_t Width;//
  int32_t Height;//
  std::unique_ptr<uint32_t[]> Data_Ptr;//   
 public:
  //-----------------------------------------------------------------------------------------
  CSprite(void);
  //------------------------------------------------------------------------------------------
  ~CSprite();
 public:
  //- -----------------------------------------------------------------------------------
  bool Load(char *file_name);// 
  void Put(IVideo *iVideo_Ptr,int32_t x,int32_t y,bool alpha);// 
  void PutSpriteItem(IVideo *iVideo_Ptr,int32_t x,int32_t y,int32_t offsetx,int32_t offsety,int32_t width,int32_t height,bool alpha);//  
  bool IsCollizionSpriteItem(IVideo *iVideo_Ptr,int32_t x,int32_t y,int32_t offsetx,int32_t offsety,int32_t width,int32_t height,bool alpha,uint8_t back_r,uint8_t back_g,uint8_t back_b);//      ,   
  void PutSpriteItemMask(IVideo *iVideo_Ptr,int32_t x,int32_t y,int32_t offsetx,int32_t offsety,int32_t width,int32_t height,uint8_t *Mask);//    
  void SetAlpha(uint8_t alpha,uint8_t r,uint8_t g,uint8_t b);//  
  void Release(void);// 
  int32_t GetWidth(void);//  
  int32_t GetHeight(void);//  
  void Normalize(void);//  
  bool Save(char *file_name);//  
 private:
  //- -----------------------------------------------------------------------------------  
};

#endif